// Animasya2.cpp:     .
#include "stdafx.h"
#include "Animasya2.h"

#define MAX_LOADSTRING 100

//  :
HINSTANCE hInst;								//  
TCHAR szTitle[MAX_LOADSTRING];					//   
TCHAR szWindowClass[MAX_LOADSTRING];			//    
HWND hWnd; 
HBITMAP maskBitmap;
POINT MousePnt;
bool dragging=false;
int a=0, close=0;

//   ,     :
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
void				MakeBitmapRegion();

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO:   .
	MSG msg;
	HACCEL hAccelTable;

	//   
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_ANIMASYA2, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	//   :
	if (!InitInstance (hInstance, nCmdShow)) return FALSE;

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_ANIMASYA2));

	int Style;
	Style = GetWindowLong(hWnd, GWL_STYLE);
	Style = Style || WS_CAPTION;
	Style = Style || WS_SYSMENU;
	
	SetWindowLong(hWnd, GWL_STYLE, Style);
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	
	SetTimer(hWnd, 1, 100, NULL);

	//   :
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;
	wcex.cbSize			= sizeof(WNDCLASSEX);
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ANIMASYA2));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= 0;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));
	return RegisterClassEx(&wcex);
}
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   hInst = hInstance; //      

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, 100, 100, NULL, NULL, hInstance, NULL);

   if (!hWnd) return FALSE;

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc, hdcBits;
	RECT wndrect;
	POINT point;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		break;
	case WM_TIMER:
		MakeBitmapRegion();
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		
		hdcBits=::CreateCompatibleDC(hdc);
		SelectObject(hdcBits, maskBitmap);
		BitBlt(hdc, 0, 0, 100, 100, hdcBits, 0, 0, SRCCOPY);
		
		DeleteObject(SelectObject(hdcBits, maskBitmap));
		DeleteDC(hdcBits);
		DeleteDC(hdc);

		EndPaint(hWnd, &ps);
		break;
	case WM_LBUTTONDOWN: //     
		GetCursorPos(&MousePnt);
		dragging = true;
		SetCapture(hWnd);
		break;
	case WM_MOUSEMOVE: //      
		if (dragging) //   , ...
		{
			GetCursorPos(&point); //    
			GetWindowRect(hWnd, &wndrect); //    
			//   
			wndrect.left = wndrect.left+(point.x - MousePnt.x);
			wndrect.top  = wndrect.top +(point.y - MousePnt.y);
			//    
			SetWindowPos(hWnd, NULL, wndrect.left, wndrect.top, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			MousePnt=point; //    
		}
		break;
	case WM_LBUTTONUP: //     
		if (dragging)
		{
			dragging=false;
			ReleaseCapture();
		}
		break;
	case WM_RBUTTONDOWN: //     
		close++;
		if (close > 1) PostQuitMessage(0);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
} 
void MakeBitmapRegion ()
{
		if (a == 0) maskBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BMP0));
		else if (a == 1) maskBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BMP1));
        else if (a == 2) maskBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BMP2));
        else if (a == 3) maskBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BMP3));
        else if (a == 4) maskBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BMP4));
        else if (a == 5) maskBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BMP5));
        else if (a == 6) maskBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BMP6));
        else if (a == 7) maskBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BMP7));
        else if (a == 8) maskBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BMP8));
        else if (a == 9) maskBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_BMP9));

		if (!maskBitmap) return;

		a++;
		if (a > 9 || a < 0) a = 0;

		COLORREF back_color;
		BITMAP bmp_o;
        
		GetObject(maskBitmap, sizeof(BITMAP), &bmp_o);
        int w = bmp_o.bmWidth;
        int h = bmp_o.bmHeight;

        HDC wnd_dc = GetDC(hWnd);
        if (hWnd   == NULL) return;
        if (wnd_dc == NULL) return;

        HDC hdc_bmp = CreateCompatibleDC (wnd_dc);
        SelectObject (hdc_bmp, maskBitmap);
        back_color = GetPixel(hdc_bmp, 0, 0);

        int x, x0, y;
        HRGN wnd_rgn;
        wnd_rgn = CreateRectRgn(0,0,0,0);
		HRGN tmp_rgn;

        x = y = 0;
        for (y; y < h; y++)
        {
                while (x < w-1)
                {
                        while(GetPixel(hdc_bmp, x, y) == back_color && x < w) x++;
                        if( x != w )
                        {
                                x0 = x;
                                while(GetPixel(hdc_bmp, x, y) != back_color && x < w) x++;
                                tmp_rgn = CreateRectRgn(x0, y, x, y+1);
                                CombineRgn(wnd_rgn, wnd_rgn, tmp_rgn, RGN_XOR);
                        }
                }
                x = 0;
        }

        SetWindowRgn(hWnd, wnd_rgn, TRUE);
        InvalidateRect(hWnd, 0, false);

		DeleteObject(wnd_rgn);
		DeleteObject(tmp_rgn);

		DeleteDC(hdc_bmp);
		DeleteDC(wnd_dc);
}